﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
'<Serializable()>
Public Class Form1
   Private Sub AddShapefile()
      Dim oOverlay As LayerOverlay
      Dim oMap As WinformsMap = WinformsMap1
      Dim sPath As String = "..\..\Data\us_states3.shp"


      Dim oProj4 As New ManagedProj4Projection(ManagedProj4Projection.GetEsriParametersString(4269), ManagedProj4Projection.GetEsriParametersString(102003))
      Dim oShapefile As New ShapeFileFeatureLayer(sPath, ShapeFileReadWriteMode.ReadWrite)
      oShapefile.FeatureSource.Projection = oProj4
      oShapefile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
      oShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      If oMap.Overlays.Count = 0 Then
         oOverlay = New LayerOverlay
         oMap.Overlays.Add("LayerOverlay", oOverlay)
      Else
         oOverlay = CType(oMap.Overlays(0), LayerOverlay)
      End If

      oShapefile.Open()
      oShapefile.Name = "Shapefile"
      oOverlay.Layers.Add(oShapefile.Name, oShapefile)

      oMap.MapUnit = GeographyUnit.Meter

      Try
         oMap.CurrentExtent = New RectangleShape(-3560138.92985054, 2599382.17946079, 3305567.52887212, -2742782.02099624)
         oShapefile.Close()
         oMap.Refresh()
      Catch ex As Exception
         MessageBox.Show("Error: " & ex.Message)
      End Try
   End Sub
   Private Sub SerializeShapefile()
      Dim oGeoSerializer As New GeoSerializer
      Dim oStream As FileStream
      Dim sFileName As String
      Dim oOverlay As LayerOverlay

      sFileName = GetUserFolder() & "Shapefile.wxd"

      '***** Open a file stream to use for serialization
      oStream = New FileStream(sFileName, FileMode.Create, FileAccess.Write, FileShare.None)

      oOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      If oOverlay.Layers(0).IsOpen Then
         oOverlay.Layers(0).Close()
      End If

      oGeoSerializer.Serialize(oOverlay.Layers(0))

      oStream.Close()


   End Sub
   Private Sub DeSerializeShapefile()
      Dim oObjLayer As Object
      Dim oGeoSerializer As New GeoSerializer
      Dim oStream As FileStream
      Dim sFileName As String = GetUserFolder() & "Shapefile.wxd"
      Dim oLayerOverLay As LayerOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      Dim oShapefile As ShapeFileFeatureLayer

      '***** Open a file stream to use for deserialization
      oStream = New FileStream(sFileName, FileMode.Open, FileAccess.Read, FileShare.Read)

      oObjLayer = oGeoSerializer.Deserialize(oStream)

      oShapefile = CType(oObjLayer, ShapeFileFeatureLayer)
      If oShapefile.IsOpen Then
         oShapefile.Close()
      End If

      Dim oProj4 As New ManagedProj4Projection(ManagedProj4Projection.GetEsriParametersString(4269), ManagedProj4Projection.GetEsriParametersString(102003))
      oProj4.Open()
      oShapefile.FeatureSource.Projection = oProj4
      'oShapefile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
      'oShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20



      oStream.Close()
      Me.WindowState = FormWindowState.Maximized
      Application.DoEvents()
      oLayerOverLay.Layers.Add(oShapefile.Name, oShapefile)
      WinformsMap1.Refresh()

   End Sub
   Private Function GetUserFolder() As String
      Dim sBasePath As String
      Dim sApplicationPath As String

      sBasePath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)
      sApplicationPath = Application.CompanyName & "\" & My.Application.Info.ProductName & "\"

      If Not Directory.Exists(sBasePath & "\" & sApplicationPath) Then
         Directory.CreateDirectory(sBasePath & "\" & sApplicationPath)
      End If

      Return sBasePath & "\" & sApplicationPath

   End Function

   Private Sub btnLoadFromServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadShapefile.Click
      AddShapefile()
   End Sub

   Private Sub btnSerialize_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
      SerializeShapefile()
   End Sub

   Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
      Dim oOverlay As LayerOverlay

      '***** Remove the WMS Layer from the map
      oOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      If oOverlay.Layers(0).IsOpen Then
         oOverlay.Layers(0).Close()
      End If
      oOverlay.Layers.Remove("Shapefile")
      Me.WindowState = FormWindowState.Normal
      WinformsMap1.Refresh()
   End Sub

   Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
      DeSerializeShapefile()
   End Sub
End Class
